#
# libresult.rb
# 2003.5/13 by tokuhisa
# ܸʸѥȹη̴֥
#
# update 2003.6/23  2ʬڤ
# update 2003.7/2   ȹ̤Τ#פΥӥåȤ̵뤹뤳Ȥˤ
# update 2004.1/19  ʸѥѥѥֹΤб

# -------------------- object --------------------
# 1Ĥβ򥪥֥

class PtSolution
    @@optpatterndic = nil
    def PtSolution.set_option_pattern_dictionary(dicname)
        @@optpatterndic = Hash.new
	fp = open(dicname,'r')
	fp.each{|line|
	    if /([0-9a-zA-Z\-]+):(.+)/ =~ line.chomp
		ptnid = $1
		ptnbdy = $2
		@@optpatterndic[ptnid] = ptnbdy
	    end
        }
	fp.close
    end

    def initialize( dbpath, sentid, sentence, bmfull, ptnid, bmall, bmvar, varlist )
        @dbpath   = dbpath                      # ǡ١ؤΥѥ
        @sentid  = sentid			# ʸֹ

	@sentence = sentence			# ʸ
        @bmfull   = bmfull     			# ʸʸбӥåȥޥå

        @ptnid    = ptnid      			# ޥåѥֹ
	@bmvar    = bmvar			# ѥѿбΥӥåȥޥå
	@bmels    = bmall ^ bmfull		# ѥΤ¾бΥӥåȥޥå
	@bmspl    = bmall & ~(bmvar | @bmels)	# ѥ̡ؿбΥӥåȥޥå
	@varlist  = varlist			# ѿХ

        # ʲϽͤ׻
					        # ѥʸ򥫥Сʻγ٤ΰ١
	@coverage = bs_count_1bit(bmall).to_f / bs_count_1bit(@bmfull)
	@sortorder = 0				# ȸν̡ʽͤ0
	@tagsent = annotate_VSEtag_to_jsent(@sentence, bmall, @varlist)     # դʸ
        @ptnbody,@similar = search_similar_sent # ѥפˤʸθ
        @correct = check_seikai			# ե饰closedtestΤߡ
    end

    attr_accessor :ptnid
    attr_accessor :coverage
    attr_accessor :sortorder
    attr_accessor :correct
    attr_accessor :bmspl

    def >(other)
	if  @coverage == other.coverage then
	    return bs_count_1bit(@bmspl) > bs_count_1bit(other.bmspl)
	else
	    return @coverage > other.coverage
	end
    end

    # ѥιǤ˱ơʸ˥դ롣
    def annotate_VSEtag_to_jsent(sentence, bmall, varlist)
	tsent = ''
	cbit = 0x1
	bytepos = 0
	state = ''
	bytelen = sentence.length
	bmvarlist = []
	varlist.each{|line|
	    if !( /^#/ =~ line[1] ) then
		bmvarlist << [line[0],line[1]]
            end
        }
	while bytepos < bytelen do
	    if bmall & cbit != 0 then
		if bmvarlist != [] && ( bmvarlist[0][0] & cbit != 0 ) then
		    tvarbit = bmvarlist[0][0].dup
		    loop {
			tsent += "<var "+bmvarlist[0][1]+">"
			begin
			    tsent += sentence[bytepos,2]
			    tvarbit = tvarbit ^ cbit
			    bytepos += 2
			    cbit = cbit << 1
			end while ( tvarbit & cbit != 0 )
			if tvarbit == 0 then
			    break;
			end
			tsent += "<els>"
			while tvarbit & cbit == 0 do
			    tsent += sentence[bytepos,2]
			    bytepos += 2
			    cbit = cbit << 1
			end
		    }
		    bmvarlist.shift
		    state = 'v'
		else
		    if state != 's' then
			state = 's'
			tsent += '<spl>'
		    end
		    tsent += sentence[bytepos,2]
		    bytepos += 2
		    cbit = cbit << 1
		end
	    else
		if state != 'e' then
		    state = 'e'
		    tsent += '<els>'
		end
		tsent += sentence[bytepos,2]
		bytepos += 2
		cbit = cbit << 1
	    end
	end
	return tsent
    end

    # -------------------- ѥθ --------------------

    def search_similar_sent
        if /([WPC]J)(\d\d\d)(\d\d\d\-\d\d)/ =~ @ptnid then
	    fp = open(@dbpath+'Ruiji/'+$1+'/'+$2+'/'+$3,'r')
	    ptnbody = fp.gets.chomp
	    simlist = []
	    while !( fp.eof? ) do
		bib    = fp.gets.chomp
		ljnum  = fp.gets.chomp
		ljbody = fp.gets.chomp
		lenum  = fp.gets.chomp
		lebody = fp.gets.chomp
		eptnid = fp.gets.chomp
		eptbdy = fp.gets.chomp
		simlist << [bib,ljnum,ljbody,lenum,lebody,eptnid,eptbdy]
	    end
	    fp.close
	    return ptnbody,simlist
	elsif @@optpatterndic != nil then
	    return @@optpatterndic[@ptnid],[['opt',nil,nil,nil,nil,nil,nil]]
	else
	    return '',[]
        end
    end

    # -------------------- 礻 --------------------

    def check_seikai
	if !( /LJ(\d\d\d)(\d\d\d)/ =~ @sentid ) then
	    return 'no_answer'
	end
	if !( File::exist?(@dbpath+'Seikai/LJ/'+$1+'/'+$2) ) then
	    return 'no_answer'
        end
	fp = open(@dbpath+'Seikai/LJ/'+$1+'/'+$2,'r')
	fp.each{|answer|
	    if answer.chomp == @ptnid then
	        return 'correct'
            end
        }
        return 'incorrect'
    end

    # -------------------- ñʥӥ奢 --------------------
    def show
        printf("PATTERN=%s    Coverage=%2.2f%%\n",@ptnid,@coverage*100)
	printf("%s\n",bs_print_by_1bit(@sentence,@bmspl|@bmvar))
    end

    # -------------------- äȥޥʥӥ奢 --------------------
    def presenter
        printf("      ____________\n")
        printf("  ___/ץѥ\\______________________________________________________________________\n")
	printf(" |                    \t\t\t(%d)  Ψ(%2.2f)  ե饰(%s)\n",@sortorder,@coverage*100,@correct)
	printf(" | %s:%s\n",@ptnid,@ptnbody)
	printf(" | %s\n",@tagsent)
        printf(" |          ____________\n")
	printf(" |  _______/ѥʸ\\_______________________________________________________________\n")
	@similar.each{|line|
	    puts ' | |  '+line[0]+':'+line[1]+"\t"+line[2]+':'+line[3]
	    puts " | |  \t\t\t\t\t"+line[4]+':'+line[5]
	    @varlist.each{|line|
		list = line[2].split(/=/)
		puts " | |   \t\t\t\t\t"+list[0]+"="+list[1]
	    }
	}
    end

end

#
# - - - - - - - - - - - - - - - - - - - - - - - -
# 1ѥξȹ̥֥

class PtResult
    @@dbpath_default = nil
    @@ljpath_default = nil

    attr_accessor :sentence
    attr_accessor :sollist

    def PtResult.set_default_dbpath(path)
        @@dbpath_default = path
    end

    def PtResult.set_default_ljpath(path)
        @@ljpath_default = path
    end

    def initialize(result,dbpath=@@dbpath_default,ljpath=@@ljpath_default)

	@dbpath = dbpath
	@ljpath = ljpath

	# ʸե̾ʷǡˤɤ߹---------------------
	/^INPUT=/ =~ result.gets
	ljfile0 = $'.chomp
	if /^\// =~ ljfile0 then
	    @ljfile = ljfile0
        else
	    @ljfile = ljpath + ljfile0
        end

	# ʸʸʸʸбӥåȥޥåס----
	@sentence = load_sentence(@ljfile)
	@bmfull = bs_set_bitmap(@sentence.euclength)

	# ʸֹγǧ ---------------------------------------
	if /LJ([0-9\/]+)/ =~ ljfile0 then
	    @sentid = $&.gsub(/\//,'')
        else
	    @sentid = nil
        end

	# 򥤥󥹥󥹥ꥹ -----------------------------------
	@sollist = []

	solflag = FALSE
        ptnid = ''
        bmall = 0
	bmvars = 0
	varlist = []
        bitree1 = BiTree.new

        result.each{|line|
	    if /PATTERN=([^=]+)=(0x[0-9a-fA-F]+)/ =~ line then
		tmp1 = $1
		tmp2 = $2.hex
		if solflag then
		    sol1 = PtSolution::new(@dbpath, @sentid, @sentence, @bmfull, ptnid, bmall, bmvars, varlist)
		    bitree1.set(sol1)
	        end
		bmvars = 0
		varlist = []
		ptnid = tmp1
		bmall = tmp2
		solflag = TRUE
#	    elsif /^(#\d*|[A-Z][A-Z_]*\d+).*=(0x[0-9a-f]+)$/ =~ line then
#	    elsif /^(#\d+|[A-Z][A-Z_]*\d+).*=(0x[0-9a-f]+)$/ =~ line then
	    elsif /^([A-Z][A-Z_]*\d+).*=(0x[0-9a-f]+)$/ =~ line then
	        varbit = $2.hex
		varlist << [varbit, $1, line.chomp]
		bmvars = bmvars | varbit
	    end
        }
	if solflag then
	    sol1 = PtSolution::new(@dbpath, @sentid, @sentence, @bmfull, ptnid, bmall, bmvars, varlist)
	    bitree1.set(sol1)
        end

	# 򥤥󥹥󥹤ν -----------------------------------
	# sort_by_matching_letters   # @sollist ¤Ӵ

	@sollist = bitree1.to_a_rev
	prev = 101.0
	rank = 0
	@sollist.each{|sol|
	    if prev != sol.coverage then
	        rank += 1
		prev = sol.coverage
	    end
	    sol.sortorder = rank
	}
	stat			   # ޥåѥθĿǹΨΤե饰

    end

    # ʸ
    # ǲϷ̥եɤʸ֤

    def load_sentence(file)
      fp = open(file,'r')
      lines = fp.to_a
      fp.close
      sentence = antimorph(lines)
      return sentence
    end

    # Ψˤ륽ƥ
=begin
    def sort_by_matching_letters
	@sollist.sort!{|s1,s2|
	    -( s1.coverage <=> s2.coverage )
	}
	n = 1
	@sollist.each{|s1|
	    s1.sortorder = n
	    n += 1
        }
    end
=end

    def stat
	ptnkind = Hash::new(0)
	@sollist.each{|sol|
	    ptnkind[sol.ptnid] = 1
	}


	@numofkind = 0
	ptnkind.values.each{|x| @numofkind += x }		# ޥåѥμ 
	@numofsol = @sollist.size  			 	# ޥåθĿ
	if @numofsol != 0 then
  	    @bestcoverage = @sollist[0].coverage		# ǹΨ
	    if @sollist[0].correct == 'no_answer' then		# Τե饰
	        @correct = 'no_answer'
	    else
		@correct = 'incorrect'
		@sollist.each{|sol|
		    if sol.correct == 'correct' then
			@correct = 'correct'
			break;
		    end
		}
            end
        else
	    @bestcoverage = 0.0
	    @correct = 'incorrect'
	end
    end

    def presenter
	printf("\n")
	printf(" ʸ = %s\n",@sentence)
	printf("\n")
	printf("  \t(%d) ׿(%d) ǹΨ(%2.2f) ե饰(%s)\n",@numofkind,@numofsol,@bestcoverage*100,@correct)
	@sollist.each{|sol|
	    sol.presenter
	}
    end
end
