#
# libtrans.rb
# ɽ饤֥
#


# ѸѥѿХɤ̤

def trans(engptn,varlist)
  engparts = Array.new(20,'')
  varlist.each{|varinfo|
    /^(\D+)(\d+)=([^=]+)=([^=]+)=/ =~ varinfo[2]
    varname = $1
    varnum = $2.to_i
    varstd = $3
    varorg = $4

    tmp = trans_with_filter(varname,varorg)
    if /[-]/ =~ tmp then
	varval = varstd
	if /\|/ =~ varval then
	    varval = $`
	else
	    varval = varval
	end
	tmp = trans_with_filter(varname,varstd)
    end
    engparts[varnum] = tmp
  }
  engsnt = ''
  while /[A-Z][A-Z_]*(\d+)/ =~ engptn do
    if engparts[$1.to_i] != nil then
        engsnt += $`+engparts[$1.to_i]
    else
        engsnt += $`
    end
    engptn = $'
  end
  engsnt += engptn

  engsnt = trans_last_filter(engsnt)

  return engsnt
end


def trans_last_filter(engsnt)

  engsnt.gsub!(/#\d+\[\]/,'')
  engsnt.gsub!(/#\d+\[\]/,'this ')
  engsnt.gsub!(/#\d+\[\]/,'that ')
  engsnt.gsub!(/(I\.obj)/,'me')
  engsnt.gsub!(/(She\.obj)|(she\.obj)/,'her')
  engsnt.gsub!(/(He\.obj)|(he\.obj)/,'him')
  engsnt.gsub!(/(We\.obj)|(we\.obj)/,'us')
  engsnt.gsub!(/(They\.obj)|(they\.obj)/,'them')
  engsnt.gsub!(/\.obj/,'')
  engsnt.gsub!(/(I\.poss)/,'my')
  engsnt.gsub!(/(She\.poss)|(she\.poss)/,'her')
  engsnt.gsub!(/(He\.poss)|(he\.poss)/,'his')
  engsnt.gsub!(/(We\.poss)|(we\.poss)/,'our')
  engsnt.gsub!(/(They\.poss)|(they\.poss)/,'their')
  engsnt.gsub!(/\.poss/,'')

  engsnt.gsub!(/ You /,' you ')
  engsnt.gsub!(/ He /,' he ')
  engsnt.gsub!(/ She /,' she ')
  engsnt.gsub!(/ It /,' it ')
  engsnt.gsub!(/ We /,' we ')
  engsnt.gsub!(/ They /,' they ')

  engsnt.gsub!(/ Your /,' your ')
  engsnt.gsub!(/ His /,' his ')
  engsnt.gsub!(/ Her /,' her ')
  engsnt.gsub!(/ Its /,' its ')
  engsnt.gsub!(/ Our /,' our ')
  engsnt.gsub!(/ Their /,' their ')

  engsnt.gsub!(/ Him /,' his ')
  engsnt.gsub!(/ Us /,' us ')
  engsnt.gsub!(/ Them /,' them ')

  engsnt.gsub!(/ The /,' the ')
  engsnt.gsub!(/ A /,' a ')
  engsnt.gsub!(/ An /,' an ')

  engsnt.gsub!(/ This /,' this ')
  engsnt.gsub!(/ That /,' that ')
  engsnt.gsub!(/ These /,' these ')
  engsnt.gsub!(/ Those /,' those ')

  engsnt.gsub!(/\(\|I\)/,'I')
  if /\(\|([a-zA-Z]+)\)/ =~engsnt then
    engsnt = $`+$1+$'
  end
  if /^([a-z])/ =~engsnt then
    engsnt = $1.capitalize+$'
  end

  return engsnt
end


# ALT-J/E Ƥ餦ˡʸˤäȺٹ򤹤롣
# ALTʤĤ

def trans_with_filter(var,japart)
  if var =~ /^AJ/ then
    engpart = trans_by_alt(japart).gsub(/(^It is )|(^We are )/,'')
  elsif var =~ /^V/ then
    engpart = trans_by_alt(''+japart).gsub(/^I,? /,'')
    if /^am / =~ engpart then
      engpart = trans_by_alt(''+japart).gsub(/^It /,'')
    end
  elsif var =~ /^TIME/ then
    engpart = trans_by_alt(japart).gsub(/(^In )|(^At )|(^On )/,'')
  elsif var =~ /(^N$)|(^NP$)/ then
    engpart = trans_by_alt(japart).gsub(/(^A )|(^An )|(^Its )|(^In )|(^At )|(^On )/,'')
  else
    engpart = trans_by_alt(japart)
  end
  return engpart.gsub(/\.$/,'').strip
end



# ALT-J/E θƤӽФ󥿥ե

def trans_by_alt(japart)
  workfile = 'ltalt'+Time::now.to_i.to_s
  ifile = '/tmp/'+workfile+'.jp'
  ofile = '/tmp/'+workfile+'.log'
  wfile = '/tmp/'+workfile+'.je'
  fp = open(ifile,'w')
  fp.puts japart.strip
  fp.close
  system( 'altr3 -batch '+ifile+' -log '+ofile+' > /dev/null' )
  fp = open(ofile,'r')
  line = fp.gets
  while !( /^\$\s+/ =~ line )
      line = fp.gets
  end
  eng = $'.chomp
  File::delete(ifile)
  File::delete(ofile)
  File::delete(wfile)

  return eng
end
